#include <X11/Xlib.h>
#include <X11/xpm.h>
#include <typeinfo.h>
#include <sprite.h>
#include "xhtile.h"
#include <stdio.h>

void TileSprite::RenderSprite(Drawable d) {
  for(int i=0;i <= (cx / TILE_SIZE) + 1;i++) {
    for(int j=0;j <= (cy / TILE_SIZE) + 1;j++) {
      XGCValues gcv;
      int sx=(int)i * TILE_SIZE - ((int)x % TILE_SIZE);
      int sy=(int)j * TILE_SIZE - ((int)y % TILE_SIZE);
      gcv.clip_x_origin = sx;
      gcv.clip_y_origin = sy;
      char t = data[((int)y / TILE_SIZE) + j][((int)x / TILE_SIZE) + i];
      if(t >= 'A') {
	gcv.clip_mask = masks[(int)(t - 65)];
	XChangeGC(host->theDisplay(),sprgc,GCClipXOrigin | GCClipYOrigin |
		  GCClipMask,&gcv);
	XCopyArea(host->theDisplay(),tiles[(int)(t - 65)],d,sprgc,0,0,
		  TILE_SIZE,TILE_SIZE,sx,sy);
      }
    }
  }
}

int TileSprite::FetchTile(int _x,int _y) {
    int i = (_x) / TILE_SIZE;
    int j = (_y) / TILE_SIZE;
    if((i < 0) || (j < 0) || (i >= tw) || (j >= th)) {
      return -1;
    }
    else {
      return data[j][i];
    }
}
